routes/web.php
<?php

use App\Http\Controllers\AdminController;
use App\Http\Controllers\AdminPermissionController;
use App\Http\Controllers\articlesController;
use App\Http\Controllers\AuthorAuthController;
use App\Http\Controllers\Cms\Auth\LoginController as AuthLoginController;
use App\Http\Controllers\AuthorAuthControole;
use App\Http\Controllers\authorController;
use App\Http\Controllers\categoryController;
use App\Http\Controllers\Cms\Auth\LoginController;
use App\Http\Controllers\Cms\HomeController as CmsHomeController;
use App\Http\Controllers\commentController;
use App\Http\Controllers\contactRequestController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\RolePermissionController;
use App\Http\Controllers\SearchConrtoller;
use App\Http\Controllers\settingController;
use App\Http\Controllers\UserAuthController;
use App\Http\Controllers\UserController;
use App\Models\ContactRequest;
use GuzzleHttp\Middleware;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [HomeController::class,'index'])->name('home');

Route::get('/blog/{id}',  [HomeController::class,'show'])
->name('home-article');

Route::get('/author/{id}',  [HomeController::class,'showAuthor'])
->name('home-author');
Route::get('/category/{id}',  [HomeController::class,'showCategory'])
->name('home-category');

Route::post('/blog/{id}/comment',[HomeController::class,'StorCommment'])->name('comments-user')->middleware('auth:user');

// Route::get('/employee',[SearchConrtoller::class,'index']);
Route::post('/search',[SearchConrtoller::class,'showSearch'])->name('search');

// Route::prefix('cms/admin')->name('cms.')->middleware('guest:admin')->group(function(){
//     Route::get('login',[LoginController::class,'showLoginForm'])->name('login');
//     Route::post('login',[LoginController::class,'login'])->name('login');
//     // Auth::routes();
// });



Route::prefix('cms/author')->middleware('guest:author')->group(function () {
    Route::get('login', [AuthorAuthController::class, 'showLogin'])->name('auth-author.login.view');
    Route::post('login', [AuthorAuthController::class, 'login'])->name('auth-author.login');
});



Route::prefix('user')->middleware('guest:user')->group(function () {
    Route::get('login', [UserAuthController::class, 'showLogin'])->name('auth-user.login.view');
    Route::post('login', [UserAuthController::class, 'login'])->name('auth-user.login');
});




Route::get('cms/dashboard',[CmsHomeController::class,'index'])->name('cms.dashboard')
->middleware('auth:admin,author');




Route::prefix('cms/admin')->name('admin.')->middleware('guest:admin')->group(function(){
    Route::get('login',[AuthLoginController::class,'showLoginForm'])->name('auth.login.view');
    Route::post('login',[AuthLoginController::class,'login'])->name('login');
    // Auth::routes();
});



Route::get('logout', [UserAuthController::class, 'logout'])->name('auth-user.logout')->middleware('auth:user');




Route::prefix('cms')->middleware('auth:admin,author')->group(function(){
Route::resource('admins', AdminController::class);
// Route::view('', 'cms.dashboard')->name('cms.dashboard');
Route::resource('contacts', contactRequestController::class);
Route::resource('comments', commentController::class);


Route::resource('roles', RoleController::class);
Route::resource('permissions', PermissionController::class);

Route::resource('admins.permissions', AdminPermissionController::class);
Route::resource('role.permissions', RolePermissionController::class);

Route::resource('settings', settingController::class)->only(['index','store']);
Route::resource('users', UserController::class);
Route::resource('authors', authorController::class);
Route::resource('categories', categoryController::class);
Route::resource('articles', articlesController::class);


Route::get('edit-password', [AuthorAuthController::class, 'editPassword'])->name('auth.edit-password');
Route::put('update-password', [AuthorAuthController::class, 'updatePassword'])->name('auth.update-password');

Route::get('author/logout', [AuthorAuthController::class, 'logout'])->name('auth-author.logout');
Route::get('logout', [AuthLoginController::class, 'logout'])->name('auth.logout');



});
Route::view('lsl', 'cms.search.index');


// Auth::routes();

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Spatie\Permission\Models\Role;

class RoleController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        $roles = Role::withCount('permissions')->paginate(10);
        return response()->view('cms.spatie.roles.index', ['roles' => $roles]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response()->view('cms.spatie.roles.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = new Role();
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role created succssefully' : "Failed to create roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
        $role = Role::findById($id, 'admin');
        return response()->view('cms.spatie.roles.edit', ['role' => $role]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        $validator = Validator($request->all(), [
            'guard' => 'required|string|in:admin,user',
            'name' => 'required|string|min:3'
        ]);

        if (!$validator->fails()) {
            $role = Role::findOrFail($id);
            $role->name = $request->get('name');
            $role->guard_name = $request->get('guard');
            $isSaved = $role->save();
            return response()->json(['message' => $isSaved ? 'Role updated succssefully' : "Failed to update roles"], $isSaved ? 200 : 400);
        } else {
            return response()->json(['message' => 'Please check required data'], 400);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $isDeleted = Role::destroy($id);
        if ($isDeleted) {
            return response()->json(['title' => 'Deleted!', 'message' => 'Role Deleted Successfully', 'icon' => 'success'], 200);
        } else {
            return response()->json(['title' => 'Failed!', 'message' => 'Delete role failed', 'icon' => 'error'], 400);
        }
    }
}

resources/views/cms/spatie/roles/create.blade.php
@extends('cms.parent')

@section('title','Create Permission')
@section('page-name','Create Permission')
@section('main-page','Permissions')
@section('sub-page','Create Permission')

@section('styles')
<!-- Select2 -->
<link rel="stylesheet" href="{{ asset('cms/plugins/select2/css/select2.min.css') }}">
<link rel="stylesheet" href="{{ asset('cms/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css') }}">
<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="container-fluid">
        <div class="row">
            <!-- left column -->
            <div class="col-md-12">
                <!-- general form elements -->
                <div class="card card-primary">
                    <div class="card-header">
                        <h3 class="card-title">Create Permission</h3>
                    </div>
                    <!-- /.card-header -->
                    <!-- form start -->
                    <form role="form" id="create_form">
                        @csrf
                        <div class="card-body">

                            <div class="form-group">
                                <label>Guards</label>
                                <select class="form-control guards" id="guard" style="width: 100%;">
                                    {{-- <option selected="selected">Alabama</option> --}}
                                    <option value="admin">Admin</option>
                                    <option value="author">Author</option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="name">Permission Name</label>
                                <input type="text" class="form-control" id="name" placeholder="Enter role name">
                            </div>
                        </div>
                        <!-- /.card-body -->

                        <div class="card-footer">
                            <button type="button" onclick="performStore()" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
                <!-- /.card -->
            </div>
            <!--/.col (left) -->
        </div>
        <!-- /.row -->
    </div><!-- /.container-fluid -->
</section>
<!-- /.content -->
@endsection

@section('scripts')
<!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<!-- Select2 -->
<script src="{{ asset('cms/plugins/select2/js/select2.full.min.js') }}"></script>
<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>

<script type="text/javascript">
    $(document).ready(function () {
        bsCustomFileInput.init();
    });

    //Initialize Select2 Elements
    $('.guards').select2({
        theme: 'bootstrap4'
    })
</script>

<script>
    function performStore(){
        let data = {
            guard: document.getElementById ('guard').value,
            name: document.getElementById('name').value,
        }
        store('/cms/roles', data)
    }
</script>

@endsection

resources/views/cms/spatie/roles/edit.blade.php
@extends('cms.parent')

@section('title','Edit Role')
@section('page-name','Edit Role')
@section('main-page','Roles')
@section('sub-page','Edit Role')

@section('styles')
<!-- Select2 -->
<link rel="stylesheet" href="{{ asset('cms/plugins/select2/css/select2.min.css') }}">
<link rel="stylesheet" href="{{ asset('cms/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css') }}">
<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">
@endsection

@section('content')
<!-- Main content -->
<section class="content">
    <div class="container-fluid">
        <div class="row">
            <!-- left column -->
            <div class="col-md-12">
                <!-- general form elements -->
                <div class="card card-primary">
                    <div class="card-header">
                        <h3 class="card-title">Create City</h3>
                    </div>
                    <!-- /.card-header -->
                    <!-- form start -->
                    <form role="form" id="create_form">
                        @csrf
                        <div class="card-body">
                            <div class="form-group">
                                <label>Guards</label>
                                <select class="form-control guards" id="guard" style="width: 100%;">
                                    {{-- <option selected="selected">Alabama</option> --}}
                                    <option value="admin" @if($role->guard_name == 'admin') selected @endif>Admin
                                    </option>
                                    <option value="author" @if($role->guard_name == 'author') selected @endif>Author
                                    </option>
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="name">Role Name</label>
                                <input type="text" class="form-control" value="{{ $role->name }}" id="name"
                                    placeholder="Enter role name">
                            </div>
                        </div>
                        <!-- /.card-body -->
                        <div class="card-footer">
                            <button type="button" onclick="performUpdate({{ $role->id }})"
                                class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>
                <!-- /.card -->
            </div>
            <!--/.col (left) -->
        </div>
        <!-- /.row -->
    </div><!-- /.container-fluid -->
</section>
<!-- /.content -->
@endsection

@section('scripts')
<!-- bs-custom-file-input -->
<script src="{{ asset('cms/plugins/bs-custom-file-input/bs-custom-file-input.min.js') }}"></script>
<!-- Select2 -->
<script src="{{ asset('cms/plugins/select2/js/select2.full.min.js') }}"></script>
<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>

<script type="text/javascript">
    $(document).ready(function () {
            bsCustomFileInput.init();
        });

        //Initialize Select2 Elements
        $('.guards').select2({
        theme: 'bootstrap4'
        })
</script>

<script>
    function performUpdate(id){
        let data = {
            guard: document.getElementById ('guard').value,
            name: document.getElementById('name').value,
        }
        let redirectUrl = '{{ route('roles.index') }}'
        update('/cms/roles/'+id, data, redirectUrl);
    }
</script>

@endsection

resources/views/cms/spatie/roles/index-permissions.blade.php
@extends('cms.parent')

@section('title','permissions')
@section('page-name','Index permissions')
@section('main-page','permissions')
@section('sub-page','Index')

@section('styles')
<!-- Toastr -->
<link rel="stylesheet" href="{{ asset('cms/plugins/toastr/toastr.min.css') }}">
<link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
<!-- iCheck for checkboxes and radio inputs -->
<link rel="stylesheet" href="{{ asset('cms/plugins/icheck-bootstrap/icheck-bootstrap.min.css') }}">
@endsection

@section('content')
<section class="content">
    <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">permissions to Role</h3>

                        <div class="card-tools">
                            <div class="input-group input-group-sm" style="width: 150px;">
                                <input type="text" name="table_search" class="form-control float-right"
                                    placeholder="Search">

                                <div class="input-group-append">
                                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body table-responsive p-0">
                        <table class="table table-hover table-bordered text-nowrap">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Name</th>
                                    <th>Guard</th>
                                    <th>Status</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($permissions as $permission)
                                <tr>
                                    <td>{{ $permission->id }}</td>
                                    <td><span class="badge bg-info">{{ $permission->name }}</span></td>
                                    <td><span class="badge bg-success">{{ $permission->guard_name }}</span></td>
                                    <td>
                                        <div class="icheck-success d-inline">
                                            <input type="checkbox" @if($permission->is_active) checked @endif
                                            onclick="performStore({{ $roleId }}, {{ $permission->id }})"
                                            id="permission_{{ $permission->id }}">
                                            <label for="permission_{{ $permission->id }}">
                                            </label>
                                        </div>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer clearfix">
                        {{-- {{ $permissions->links() }} --}}
                        <!-- /.card-body -->
                    </div>
                    <!-- /.card -->
                </div>
            </div>
            <!-- /.row -->
        </div>
</section>
@endsection

@section('scripts')
<!-- Toastr -->
<script src="{{ asset('cms/plugins/toastr/toastr.min.js') }}"></script>

<script>
    function performStore(roleId,permissionId){
        let data = {
            permission_id: permissionId,
        }
        store('/cms/role/'+roleId+'/permissions', data)
    }
</script>
@endsection

resources/views/cms/spatie/roles/index.blade.php
@extends('cms.parent')

@section('title','Roles')
@section('page-name','Index Roles')
@section('main-page','Roles')
@section('sub-page','Index')

@section('styles')
<link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
@endsection

@section('content')
<section class="content">
    <div class="container-fluid">
        <!-- /.row -->
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-header">
                        <h3 class="card-title">Cities</h3>

                        <div class="card-tools">
                            <div class="input-group input-group-sm" style="width: 150px;">
                                <input type="text" name="table_search" class="form-control float-right"
                                    placeholder="Search">

                                <div class="input-group-append">
                                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- /.card-header -->
                    <div class="card-body table-responsive p-0">
                        <table class="table table-hover table-bordered text-nowrap">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Name</th>
                                    <th>Guard</th>
                                    <th>Permissions</th>
                                    <th>Created At</th>
                                    <th>Updated  At</th>
                                    <th>Settings</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($roles as $role)
                                <tr>
                                    <td>{{ $role->id }}</td>
                                    <td>{{ $role->name }}</td>
                                    <td><span class="badge bg-success">{{ $role->guard_name }}</span></td>
                                    <td><a href="{{ route('role.permissions.index',$role->id) }}"
                                            class="btn btn-info">{{ $role->permissions_count }} /
                                            Permissions <i class="fas fa-user-tie"></i></a></td>
                                    <td>{{ $role->created_at->format('Y-m-d') }}</td>
                                    <td>{{ $role->updated_at->format('Y-m-d') }}</td>
                                    <td>
                                        <div class="btn-group">
                                            <a href="{{ route('roles.edit',$role->id) }}" type="button"
                                                class="btn btn-info"><i class="fas fa-edit"></i></a>
                                            <a href="#" class="btn btn-danger"
                                                onclick="performDestroy({{ $role->id }}, this)"><i
                                                    class="fas fa-trash"></i></a>
                                        </div>
                                    </td>
                                </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                    <div class="card-footer clearfix">
                        {{ $roles->links() }}
                        {{-- {{ $cities->render }} --}}
                    </div>
                    <!-- /.card-body -->
                </div>
                <!-- /.card -->
            </div>
        </div>
        <!-- /.row -->
    </div>
</section>
@endsection

@section('scripts')
<script>
    function performDestroy(id, td){
        confirmDestroy('/cms/roles/'+id, td)
    }
</script>
@endsection